#include <windows.h>
#include <windowsx.h>


LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);


TCHAR g_lpszClassName[] = TEXT("_Skelton_");


#define IDM_LAYERED_TIMER (100)


//////////////////////////////////////////////////////////////////////////


int WINAPI WinMain( HINSTANCE hInstance,  HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd) {

	MSG Msg;
	WNDCLASSEX wcl;
	HWND hwnd;
	
	wcl.cbSize = sizeof(WNDCLASSEX);
	wcl.hInstance = hInstance;
	wcl.lpszClassName = g_lpszClassName;
	wcl.lpfnWndProc = WndProc;
	wcl.style = NULL;
	wcl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
	wcl.hIconSm = NULL;
	wcl.hCursor = LoadCursor (NULL, IDC_ARROW);
	wcl.lpszMenuName = NULL;
	wcl.cbClsExtra = 0;
	wcl.cbWndExtra = 0;
	wcl.hbrBackground = (HBRUSH) GetStockObject(GRAY_BRUSH);

	if(!RegisterClassEx(&wcl)) {
		return FALSE;
	}

	hwnd = CreateWindowEx( 
		0,
		g_lpszClassName,
		TEXT("AnimateWindow Windows Sample"),
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, 	CW_USEDEFAULT,
		400, 400,
		NULL, NULL, hInstance, NULL);

	if(!hwnd) {
		return FALSE;
	}

	ShowWindow( hwnd, nShowCmd);
	UpdateWindow(hwnd);

	while(GetMessage(&Msg, NULL, 0, 0)) {

		DispatchMessage(&Msg);

	}

	return Msg.wParam;
	
}


///////////////////////////////////////////////////////////////////////////////


BOOL OnCreate(HWND hwnd, LPCREATESTRUCT lpCreateStruct) {
	
	AnimateWindow(hwnd, 200, AW_VER_NEGATIVE);
	SetForegroundWindow(hwnd);

	return TRUE;
}


///////////////////////////////////////////////////////////////////////////////


void OnDestroy(HWND hwnd) {

	PostQuitMessage(0);
	
}


///////////////////////////////////////////////////////////////////////////////


void OnTimer(HWND hwnd, UINT id) {

	switch (id) {
	case IDM_LAYERED_TIMER:

		KillTimer (hwnd, IDM_LAYERED_TIMER);
		PostQuitMessage(0);
		
		break;
	default:
		break;
	}

}


///////////////////////////////////////////////////////////////////////////////


void OnLButtonUp(HWND hwnd, int x, int y, UINT keyFlags) {

	DWORD dwTime = 500;
	SetTimer(hwnd, IDM_LAYERED_TIMER, dwTime + 100, NULL);
	AnimateWindow(hwnd, dwTime, AW_HIDE | AW_BLEND);
	
}


///////////////////////////////////////////////////////////////////////////////


LRESULT CALLBACK WndProc( HWND hwnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	switch(Msg) {
	HANDLE_MSG (hwnd, WM_TIMER, OnTimer);
	HANDLE_MSG (hwnd, WM_CREATE, OnCreate);
	HANDLE_MSG (hwnd, WM_DESTROY, OnDestroy);
	HANDLE_MSG (hwnd, WM_LBUTTONUP, OnLButtonUp);
	}

	return DefWindowProc(hwnd, Msg, wParam, lParam);
	
}
